package com.muyu.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.muyu.common.core.annotation.Excel;
import com.muyu.common.core.web.domain.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

@Data
@AllArgsConstructor
@NoArgsConstructor
@SuperBuilder
@EqualsAndHashCode(callSuper = true)
@TableName(value ="table_info",autoResultMap = true) //数据库表相关
public class DictInfo extends BaseEntity {
    /** 主键 */
    @TableId(value = "id",type = IdType.AUTO)
    private Long id;

    /** 接入id */
    @Excel(name = "字典id")
    private Long dictId;

    /** 字典名称 */
    @Excel(name = "字典名称")
    private String infoName;

    /** 字典类型 */
    @Excel(name = "字典类型")
    private String infoValue;

    @JsonProperty("isEdit")
    private boolean isEdit;

}
